Codeforces Round #514 (Div. 2) D. Nature Reserve

http://codeforces.com/contest/1059/problem/D

最大值:

最左下方和最右下方分别有一个点

r^2 - (r-1)^2 = (10^7)^2

maxr<0.5*10^14

Way1:

二分。

difference:

如果使用 5*10^13 -> 10^-6,2^ 60~70区间,pow,sqrt运算,实测超时。

实际上是,使用

time of a case:->

Code:

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 const int maxn=1e5+10;
 4
 5 double x[maxn],y[maxn];
 6 double z=5.0*1e13;
 7 int n;
 8
 9 bool work(double m)
10 {
11     double p,q,d;
12     int i;
13     p=-z; q=z;
14     for (i=1;i<=n;i++)
15     {
16         d=sqrt(pow(m,2)-pow(m-y[i],2));
17         p=max(p,x[i]-d);
18         q=min(q,x[i]+d);
19 //        if (p>q)
20 //            return 0;
21     }
22 //    return 1;
23     if (p<=q)
24         return 1;
25     else
26         return 0;
27 }
28
29 int main()
30 {
31     double l=0,r,m;
32     int v,i;
33     scanf("%d",&n);
34     v=0;
35     for (i=1;i<=n;i++)
36     {
37         scanf("%lf%lf",&x[i],&y[i]);
38         if (y[i]!=0)
39         {
40             if (v==0)
41                 v=(y[i]>0);
42             else if (v!=(y[i]>0))
43             {
44                 printf("-1");
45                 return 0;
46             }
47         }
48         y[i]=fabs(y[i]);
49         l=max(l,y[i]/2);
50     }
51     r=z;
52     while ((r-l)/max(1.0,l)>1e-6)
53     {
54         m=(l+r)/2;
55         if (work(m))
56             r=m;
57         else
58             l=m;
59     }
60     printf("%.10f",r);
61     return 0;
62 }

Way2:

多个二次函数f1,f2,…,fn,

f(x)=max(f1(x),f2(x),…,fn(x)),

而f是先减小,后增大,使用三分法

类似:

hdu4717 The Moving Points

原文地址:https://www.cnblogs.com/cmyg/p/9784683.html

时间: 2024-08-30 17:26:06

Codeforces Round #514 (Div. 2) D. Nature Reserve的相关文章

Codeforces Round #514 (Div. 2) C. Sequence Transformation(递归)

C. Sequence Transformation 题目链接:https://codeforces.com/contest/1059/problem/C 题意: 现在有1~n共n个数,然后执行下面操作: 1.求出余下数的gcd,然后将gcd加入答案队列: 2.从中任意删除一个数,如果余下数的个数大于0,回到步骤1. 问答案队列字典序最大是什么. 题解: 这明明是递归在做极其方便,我偏偏用for循环来搞,加各种判断... 首先对于1,2,3...n来说,我们每次删去一个数时,肯定首先删去的是奇数

Codeforces Round #514 (Div. 2)

1059A - Cashier #include<cstdio> const int N=1e5+5; int l[N],t[N]; int main(){ int n,L,a,ans=0; scanf("%d%d%d",&n,&L,&a); for(int i=1;i<=n;++i) scanf("%d%d",&t[i],&l[i]); if(l[1]) ans+=t[1]/a; t[n+1]=L; for

Codeforces Round #514 (Div. 2) C. Sequence Transformation 思维构造

题意 给出一个1-n的集合   gcd 集合里面的所有数  得到的 一个 数   然后自己选择删去一个数   要使得到的数 构成的数列 的字典序最大 思路: gcd所有数 那gcd得到的数肯定要小于数组中最小的数  所以 刚开始都是1   所以优先删去1  那就要使gcd所有数经可能快得到 2 如何快速到2 呢 那就是把奇数全部删掉  那剩下得数最小就为2 了  此时为 2 4 6 8 10....  此刻就从2开始删   当n==3时 有 x ,2x,3x  此时 只有 删 x 2 x   3

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f